/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.builders.block;

import java.util.List;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import buildcraft.api.properties.BuildCraftProperties;

import buildcraft.lib.block.BlockBCTile_Neptune;
import buildcraft.lib.block.IBlockWithFacing;

import buildcraft.builders.BCBuildersGuis;
import buildcraft.builders.tile.TileArchitectTable;

public class BlockArchitectTable extends BlockBCTile_Neptune implements IBlockWithFacing {
    public static final IProperty<Boolean> PROP_VALID = BuildCraftProperties.VALID;

    private static final int META_VALID_INDEX = 4;

    public BlockArchitectTable(Material material, String id) {
        super(material, id);
        func_180632_j(func_176223_P().func_177226_a(PROP_VALID, Boolean.TRUE));
    }

    @Override
    protected void addProperties(List<IProperty<?>> properties) {
        super.addProperties(properties);
        properties.add(PROP_VALID);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        IBlockState state = super.func_176203_a(meta);
        state = state.func_177226_a(PROP_VALID, (meta & META_VALID_INDEX) == 0);
        return state;
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return super.func_176201_c(state) | (state.func_177229_b(PROP_VALID) ? 0 : META_VALID_INDEX);
    }

    @Override
    public TileEntity func_149915_a(World world, int meta) {
        return new TileArchitectTable();
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (!world.field_72995_K) {
            BCBuildersGuis.ARCHITECT.openGUI(player, pos);
        }
        return true;
    }

    @Override
    public boolean canBeRotated(World world, BlockPos pos, IBlockState state) {
        return false;
    }
}
