/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.builders.client.render;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.VertexBuffer;

import net.minecraftforge.client.model.animation.FastTESR;

import buildcraft.lib.client.render.laser.RenderLaserBox;

import buildcraft.builders.tile.TileArchitectTable;
import buildcraft.core.client.BuildCraftLaserManager;

public class RenderArchitectTable extends FastTESR<TileArchitectTable> {
    @Override
    public void renderTileEntityFast(@Nonnull TileArchitectTable tile, double x, double y, double z, float partialTicks, int destroyStage, @Nonnull VertexBuffer vb) {
        Minecraft.func_71410_x().field_71424_I.func_76320_a("bc");
        Minecraft.func_71410_x().field_71424_I.func_76320_a("architect_table");

        Minecraft.func_71410_x().field_71424_I.func_76320_a("box");
        if (tile.markerBox) {
            vb.func_178969_c(x - tile.func_174877_v().func_177958_n(), y - tile.func_174877_v().func_177956_o(), z - tile.func_174877_v().func_177952_p());
            RenderLaserBox.renderDynamic(tile.box, BuildCraftLaserManager.STRIPES_READ, vb, false);
            vb.func_178969_c(0, 0, 0);
        }
        Minecraft.func_71410_x().field_71424_I.func_76319_b();

        Minecraft.func_71410_x().field_71424_I.func_76319_b();
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
    }

    @Override
    public boolean func_188185_a(TileArchitectTable te) {
        return true;
    }
}
