/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.core.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;

import buildcraft.api.enums.EnumDecoratedBlock;
import buildcraft.api.properties.BuildCraftProperties;

import buildcraft.lib.block.BlockBCBase_Neptune;

public class BlockDecoration extends BlockBCBase_Neptune {
    public static final IProperty<EnumDecoratedBlock> DECORATED_TYPE = BuildCraftProperties.DECORATED_BLOCK;

    public BlockDecoration(String id) {
        super(Material.field_151573_f, id);
        func_180632_j(func_176223_P().func_177226_a(DECORATED_TYPE, EnumDecoratedBlock.DESTROY));
    }

    // IBlockState

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DECORATED_TYPE);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        IBlockState state = func_176223_P();
        return state.func_177226_a(DECORATED_TYPE, EnumDecoratedBlock.fromMeta(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(DECORATED_TYPE).ordinal();
    }

    // Other

    @Override
    public void func_149666_a(Item item, CreativeTabs tab, NonNullList<ItemStack> list) {
        for (EnumDecoratedBlock type : EnumDecoratedBlock.values()) {
            list.add(new ItemStack(this, 1, type.ordinal()));
        }
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return state.func_177229_b(DECORATED_TYPE).ordinal();
    }

    @Override
    public int getLightValue(IBlockState state, IBlockAccess world, BlockPos pos) {
        EnumDecoratedBlock type = state.func_177229_b(DECORATED_TYPE);
        return type.lightValue;
    }
}
