/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.factory;

import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;

import buildcraft.api.BCBlocks;

import buildcraft.lib.recipe.OredictionaryNames;
import buildcraft.lib.recipe.RecipeBuilderShaped;

public class BCFactoryRecipes {
    public static void init() {
        if (BCBlocks.FACTORY_AUTOWORKBENCH_ITEM != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("gwg");
            builder.map('w', "craftingTableWood");
            builder.map('g', "gearStone");
            builder.setResult(new ItemStack(BCBlocks.FACTORY_AUTOWORKBENCH_ITEM));
            builder.register();
            builder.registerRotated();
        }

        if (BCBlocks.FACTORY_MINING_WELL != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("iri");
            builder.add("igi");
            builder.add("ipi");
            builder.map('i', "ingotIron");
            builder.map('r', "dustRedstone");
            builder.map('g', "gearIron");
            builder.map('p', Items.field_151035_b);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_MINING_WELL));
            builder.register();
        }

        if (BCBlocks.FACTORY_TANK != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("ggg");
            builder.add("g g");
            builder.add("ggg");
            builder.map('g', OredictionaryNames.GLASS_COLOURLESS);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_TANK));
            builder.register();
        }

        if (BCBlocks.FACTORY_PUMP != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("iri");
            builder.add("igi");
            builder.add("tbt");
            builder.map('i', "ingotIron");
            builder.map('r', "dustRedstone");
            builder.map('g', "gearIron");
            builder.map('b', Items.field_151133_ar);
            builder.map('t', BCBlocks.FACTORY_TANK, OredictionaryNames.GLASS_COLOURLESS);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_PUMP));
            builder.register();
        }

        if (BCBlocks.FACTORY_FLOOD_GATE != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("igi");
            builder.add("btb");
            builder.add("ibi");
            builder.map('i', "ingotIron");
            builder.map('g', OredictionaryNames.GEAR_IRON);
            builder.map('b', Blocks.field_150411_aY);
            builder.map('t', BCBlocks.FACTORY_TANK, OredictionaryNames.GLASS_COLOURLESS);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_FLOOD_GATE));
            builder.register();
        }

        if (BCBlocks.FACTORY_CHUTE != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("ici");
            builder.add("igi");
            builder.add(" i ");
            builder.map('i', "ingotIron");
            builder.map('g', OredictionaryNames.GEAR_STONE);
            builder.map('c', Blocks.field_150486_ae);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_CHUTE));
            builder.register();
        }

        if (BCBlocks.FACTORY_DISTILLER != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("rtr");
            builder.add("tgt");
            builder.map('r', Blocks.field_150429_aA);
            builder.map('g', OredictionaryNames.GEAR_DIAMOND);
            builder.map('t', BCBlocks.FACTORY_TANK, OredictionaryNames.GLASS_COLOURLESS);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_DISTILLER));
            builder.register();
        }

        if (BCBlocks.FACTORY_HEAT_EXCHANGE_START != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("IGI");
            builder.add("###");
            builder.add("G#G");
            builder.map('I', Items.field_151042_j);
            builder.map('G', OredictionaryNames.GEAR_IRON);
            builder.map('#', Blocks.field_150359_w);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_HEAT_EXCHANGE_START));
            builder.register();
        }

        if (BCBlocks.FACTORY_HEAT_EXCHANGE_MIDDLE != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("IGI");
            builder.add("###");
            builder.add("IGI");
            builder.map('I', Items.field_151042_j);
            builder.map('G', OredictionaryNames.GEAR_IRON);
            builder.map('#', Blocks.field_150359_w);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_HEAT_EXCHANGE_MIDDLE));
            builder.register();
        }

        if (BCBlocks.FACTORY_HEAT_EXCHANGE_END != null) {
            RecipeBuilderShaped builder = new RecipeBuilderShaped();
            builder.add("G#G");
            builder.add("###");
            builder.add("IGI");
            builder.map('I', Items.field_151042_j);
            builder.map('G', OredictionaryNames.GEAR_IRON);
            builder.map('#', Blocks.field_150359_w);
            builder.setResult(new ItemStack(BCBlocks.FACTORY_HEAT_EXCHANGE_END));
            builder.register();
        }
    }
}
