/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.client.guide.parts;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.item.ItemStack;

import buildcraft.lib.client.guide.GuiGuide;
import buildcraft.lib.client.guide.GuideManager;
import buildcraft.lib.gui.pos.GuiRectangle;

public abstract class GuidePartItem extends GuidePart {
    public static final GuiRectangle STACK_RECT = new GuiRectangle(0, 0, 16, 16);

    public GuidePartItem(GuiGuide gui) {
        super(gui);
    }

    protected void drawItemStack(ItemStack stack, int x, int y) {
        if (stack != null && !stack.func_190926_b()) {
            GlStateManager.func_179124_c(1, 1, 1);
            FontRenderer fr = Minecraft.func_71410_x().field_71466_p;
            gui.field_146297_k.func_175599_af().func_175042_a(stack, x, y);
            gui.field_146297_k.func_175599_af().func_175030_a(fr, stack, x, y);
            if (STACK_RECT.offset(x, y).contains(gui.mouse)) {
                gui.tooltipStack = stack;
            }
            GlStateManager.func_179124_c(1, 1, 1);
        }
    }

    protected void testClickItemStack(ItemStack stack, int x, int y) {
        if (stack != null && !stack.func_190926_b() && STACK_RECT.offset(x, y).contains(gui.mouse)) {
            gui.openPage(GuideManager.INSTANCE.getPageFor(stack).createNew(gui));
        }
    }
}
